# coding: utf-8

"""
    Tator REST API

    Interface to the Tator backend.  # noqa: E501

    The version of the OpenAPI document: v1
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from ..configuration import Configuration


class AlgorithmLaunch(object):
    """
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'gid': 'str',
        'message': 'str',
        'uid': 'list[str]'
    }

    attribute_map = {
        'gid': 'gid',
        'message': 'message',
        'uid': 'uid'
    }

    def __init__(self, gid=None, message=None, uid=None, local_vars_configuration=None):  # noqa: E501
        """AlgorithmLaunch - a model defined in OpenAPI"""
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._gid = None
        self._message = None
        self._uid = None
        self.discriminator = None

        if gid is not None:
            self.gid = gid
        if message is not None:
            self.message = message
        if uid is not None:
            self.uid = uid

    @property
    def gid(self):
        """
        A uuid string identifying the group of jobs started.

        :return: The gid of this AlgorithmLaunch. 
        :rtype: str
        """
        return self._gid

    @gid.setter
    def gid(self, gid):
        """
        A uuid string identifying the group of jobs started.

        :param gid: The gid of this AlgorithmLaunch.
        :type: str
        """

        self._gid = gid

    @property
    def message(self):
        """
        Message indicating successful launch.

        :return: The message of this AlgorithmLaunch. 
        :rtype: str
        """
        return self._message

    @message.setter
    def message(self, message):
        """
        Message indicating successful launch.

        :param message: The message of this AlgorithmLaunch.
        :type: str
        """

        self._message = message

    @property
    def uid(self):
        """
        A list of uuid strings identifying each job started.

        :return: The uid of this AlgorithmLaunch. 
        :rtype: list[str]
        """
        return self._uid

    @uid.setter
    def uid(self, uid):
        """
        A list of uuid strings identifying each job started.

        :param uid: The uid of this AlgorithmLaunch.
        :type: list[str]
        """

        self._uid = uid

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AlgorithmLaunch):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, AlgorithmLaunch):
            return True

        return self.to_dict() != other.to_dict()
