# coding: utf-8

"""
    Tator REST API

    Interface to the Tator backend.  # noqa: E501

    The version of the OpenAPI document: v1
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from ..configuration import Configuration


class StreamingConfig(object):
    """
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'resolutions': 'list[ResolutionConfig]'
    }

    attribute_map = {
        'resolutions': 'resolutions'
    }

    def __init__(self, resolutions=None, local_vars_configuration=None):  # noqa: E501
        """StreamingConfig - a model defined in OpenAPI"""
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._resolutions = None
        self.discriminator = None

        if resolutions is not None:
            self.resolutions = resolutions

    @property
    def resolutions(self):
        """
        Array of resolutions to encode for streaming.If set to null, the defaults are used (libx264 at 144p,320p,480p,720p,1080p)

        :return: The resolutions of this StreamingConfig. 
        :rtype: list[ResolutionConfig]
        """
        return self._resolutions

    @resolutions.setter
    def resolutions(self, resolutions):
        """
        Array of resolutions to encode for streaming.If set to null, the defaults are used (libx264 at 144p,320p,480p,720p,1080p)

        :param resolutions: The resolutions of this StreamingConfig.
        :type: list[ResolutionConfig]
        """

        self._resolutions = resolutions

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, StreamingConfig):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, StreamingConfig):
            return True

        return self.to_dict() != other.to_dict()
